﻿@model BillingMethodsViewModel
@{
    ViewBag.IsRegistrantReport = true;

}

<div class="container">
    <div class="row">
        <div class="col-md-12">

            <div class="title-page">
                <h1>
                    Payment methods
                </h1>
            </div>
            @if (ViewBag.HasInstallment)
            {
                <label style="padding: 5px;font-size:17px"><span class="icon" style="color:#e7830d;vertical-align: middle;" data-icon="" title=""></span> You need to have at least one payment method because your installments are in progress.</label>
            }
          
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            @Html.Partial("_BillingMethodsItems", Model.BillingMethodsItem)
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
          
            <div id="EmptyGrid" class="success" style="display:none">

                <h5>You do not have any saved payment methods.</h5>
            </div>
            <span id="AddNewCardLink" onClick="AddNewCard()" class="btn btn_side-right-bottom btn_color-green" style="margin-bottom:5px;">Add payment method</span>

            <div id="AddNewCard">

            </div>


        </div>
    </div>
</div>
@section Scripts
{
    <script type="text/javascript">

        var DeleteCardOptions = {
            message: "Are you sure you want to remove this payment method?",
            title: 'Remove payment method',
            size: eModal.size.xl,
            subtitle: 'smaller text header',
            label: "Yes"   // use the positive label as key

        };

        var SetActiveOptions = {
            message: "When you change your active payment method, you may automatically be charged for any outstanding balance. Are you sure you want to proceed with this action?",
            title: 'Activate payment method',
            size: eModal.size.xl,
            subtitle: 'smaller text header',
            label: "Yes"   // use the positive label as key

        };

        function DeleteCard(Id) {

            eModal.confirm(DeleteCardOptions).then(callback, function () { return false; });

            function callback() {
                $.ajax({
                    type: "POST",
                    url: "/Registrant/DeleteCard",
                    cache: false,
                    data: { Id: Id },
                    success: function (data) {

                        toastr.success("You have successfully removed your credit card.");
                        var grid = $("#ParentCreditCardGrid").data("kendoGrid");
                        grid.dataSource.read();

                    },
                    error: function (req) {
                        toastr.error("Error in your credit remove.");
                    }
                });
            };

            return false;
        }


        function SetActive(id, userId) {
            eModal.confirm(SetActiveOptions).then(callback, function () { return false; });
            function callback() {
                $.ajax({
                    type: 'Post',
                    url: "/Registrant/ActivateCard",
                    cache: false,
                    data: { cardId: id, userId: userId },
                    success: function (data) {

                        toastr.success("You have successfully set your credit card as active.");
                        var grid = $("#ParentCreditCardGrid").data("kendoGrid");
                        grid.dataSource.read();

                    },
                    error: function (req) {
                        toastr.error("Error in setting your credit card as active.");
                    }
                });
            }
            return false;
        }

        function EditUserCard(id) {
            $("#AddNewCardLink").hide();
            $.ajax({
                type: "Get",
                url: "/Registrant/CreateEditUserCard",
                cache: false,
                data: { cardId: id },
                success: function (data) {

                    $("#AddNewCard").html(data);
                    $("#AddNewCard").show("slow");
                },
                error: function (req) {
                    toastr.error("The billing info updated fail.");
                },
                complete: function (data) { initMap(); }
            });

            return false;
        }

        function onFailure(data) {
            toastr.error(data);
            $("#resultTarget").html(data);
            initMap();

        }
        function CreateEditCardSuccess(data) {

            if (data.status) {
                $("#AddNewCard").hide("slow");
                $("#AddNewCardLink").show("slow");
                if (data.PageMode == 1) {
                    toastr.success("You have successfully added your credit card.");
                    var grid = $("#ParentCreditCardGrid").data("kendoGrid");
                    grid.dataSource.read();
                    var gridlength = $("#ParentCreditCardGrid").data("kendoGrid").dataSource.data().length;

                    if (!(gridlength > 0)) {
                        location.reload();
                    }

                }
                else {
                    toastr.success("You have successfully updated your credit card.");
                    var grid = $("#ParentCreditCardGrid").data("kendoGrid");
                    grid.dataSource.read();
                }
            }
            else {
                $("#resultTarget").html(data);
                var gridlength = $("#ParentCreditCardGrid").data("kendoGrid").dataSource.data().length;
                if (gridlength == 0) {

                    var setactive = document.getElementById("SetActiveCheck");
                    setactive.checked = true;
                    setactive.setAttribute("disabled", "true");
                }

                else if (gridlength > 0) { $("#ParentCreditCardGrid").show(); }
                initMap();
            }
        }

        function AddNewCard() {

            $("#AddNewCardLink").hide();

            $.ajax({
                type: "Get",
                url: "/Registrant/CreateEditUserCard",
                cache: false,
                success: function (data) {
                    $("#AddNewCard").html(data);
                    $("#AddNewCard").show("slow");
                    var gridlength = $("#ParentCreditCardGrid").data("kendoGrid").dataSource.data().length;

                    if (gridlength == 0) {

                        var setactive = document.getElementById("SetActiveCheck");
                        setactive.checked = true;
                        setactive.setAttribute("disabled", "true");
                    }

                    else if (gridlength > 0) { $("#ParentCreditCardGrid").show(); }

                },
                error: function (req) {
                    $("#AddNewCard").show("slow");
                    var gridlength = $("#ParentCreditCardGrid").data("kendoGrid").dataSource.data().length;

                    if (gridlength == 0) {

                        var setactive = document.getElementById("SetActiveCheck");
                        setactive.checked = true;
                        setactive.setAttribute("disabled", "true");
                    }

                    else if (gridlength > 0) { $("#ParentCreditCardGrid").show(); }
                },
                complete: function (data) { initMap(); }
            });
            return false;

        }
        function Cancel() {
            $("#AddNewCardLink").show();
            $("#AddNewCard").hide("slow");
        }
        function Action(userid) {

            $(userid).toggle("slow");

        }

        function kendoEmptyGridFix() {

            $("[data-role='grid']").each(function () {
                $(this).data("kendoGrid").bind('detailInit', function (e) {
                    kendoEmptyGridFix();
                });
                $(this).data("kendoGrid").bind('dataBound', function (e) {
                    if ($(this)[0].dataSource._view.length == 0) {
                        $("#ParentCreditCardGrid").hide();
                        $("#EmptyGrid").show();

                    };
                });
            });
        }

        $(document).ready(function () {

            kendoEmptyGridFix();

        });

    </script>
}